#include "stdafx.h"
#include <windows.h>

class Small 
{ 
public: 
	UINT32		field1, 
				field2, 
				field3, 
				field4, 
				field5;
};

class Big 
{ 
public: 
	InterfaceSpec *field1; 
	Small *field2; 
	UINT32 theRest[154]; 
	UINT32 lastField; 
};


Big *load_dll(const char *dllName)
{
	// Load the library
	HINSTANCE hDll = LoadLibrary(dllName);
	if (hDll == NULL)
	{
		MessageBox(NULL, "Failed to load dll", "Error", MB_OK);
		return NULL;
	}

	// Declare a function pointer
	Big *(*func)();

	// Get the pointer to an export and check it
	func = (Big *(*)())GetProcAddress(hDll, "CreateInterface");
	if (func == NULL) 
	{
		MessageBox(NULL, "Failed to get the export", "Error", MB_OK);
		FreeLibrary(hDll);
		return NULL;
	}

	return func();
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	Big *pbig = load_dll("..\\fd_usb\\fd_usb_original.dll");
	if (pbig == NULL)
		MessageBox(NULL, "Invalid interface pointer", "Error", MB_OK);
	
	return 0;
}



